TagLib::ID3v2::UserTextIdentificationFrame Class Reference

An ID3v2 custom text identification frame implementation. More...

`#include <textidentificationframe.h>`

Inheritance diagram for TagLib::ID3v2::UserTextIdentificationFrame:
[legend]
Collaboration diagram for TagLib::ID3v2::UserTextIdentificationFrame:
[legend]

## Public Member Functions

| UserTextIdentificationFrame (String::Type encoding=String::Latin1)
| UserTextIdentificationFrame (const ByteVector &data)
| UserTextIdentificationFrame (const String &description, const StringList &values, String::Type encoding=String::UTF8)
| ~UserTextIdentificationFrame () override
| UserTextIdentificationFrame (const UserTextIdentificationFrame &)=delete
UserTextIdentificationFrame & | operator= (const UserTextIdentificationFrame &)=delete
String | toString () const override
String | description () const
void | setDescription (const String &s)
void | setText (const String &text) override
void | setText (const StringList &fields)
PropertyMap | asProperties () const override
Public Member Functions inherited from TagLib::ID3v2::TextIdentificationFrame
| TextIdentificationFrame (const ByteVector &type, String::Type encoding)
| TextIdentificationFrame (const ByteVector &data)
| ~TextIdentificationFrame () override
| TextIdentificationFrame (const TextIdentificationFrame &)=delete
TextIdentificationFrame & | operator= (const TextIdentificationFrame &)=delete
void | setText (const StringList &l)
StringList | toStringList () const override
String::Type | textEncoding () const
void | setTextEncoding (String::Type encoding)
StringList | fieldList () const
Public Member Functions inherited from TagLib::ID3v2::Frame
virtual | ~Frame ()
| Frame (const Frame &)=delete
Frame & | operator= (const Frame &)=delete
ByteVector | frameID () const
unsigned int | size () const
unsigned int | headerSize () const
void | setData (const ByteVector &data)
ByteVector | render () const
Header * | header () const

## Static Public Member Functions

static UserTextIdentificationFrame * | find (const Tag *tag, const String &description)
static String | keyToTXXX (const String &)
static String | txxxToKey (const String &)
Static Public Member Functions inherited from TagLib::ID3v2::TextIdentificationFrame
static TextIdentificationFrame * | createTIPLFrame (const PropertyMap &properties)
static TextIdentificationFrame * | createTMCLFrame (const PropertyMap &properties)
static const KeyConversionMap & | involvedPeopleMap ()
Static Public Member Functions inherited from TagLib::ID3v2::Frame
static ByteVector | textDelimiter (String::Type t)
static ByteVector | keyToFrameID (const String &)
static String | frameIDToKey (const ByteVector &)

## Friends

class | FrameFactory

## Additional Inherited Members

Static Public Attributes inherited from TagLib::ID3v2::Frame
static const String | instrumentPrefix
static const String | commentPrefix
static const String | lyricsPrefix
static const String | urlPrefix
Protected Member Functions inherited from TagLib::ID3v2::TextIdentificationFrame
void | parseFields (const ByteVector &data) override
ByteVector | renderFields () const override
| TextIdentificationFrame (const ByteVector &data, Header *h)
Protected Member Functions inherited from TagLib::ID3v2::Frame
| Frame (const ByteVector &data)
| Frame (Header *h)
void | setHeader (Header *h, bool deleteCurrent=true)
void | parse (const ByteVector &data)
ByteVector | fieldData (const ByteVector &frameData) const
String | readStringField (const ByteVector &data, String::Type encoding, int *position=nullptr)
String::Type | checkTextEncoding (const StringList &fields, String::Type encoding) const
Static Protected Member Functions inherited from TagLib::ID3v2::Frame
static void | splitProperties (const PropertyMap &original, PropertyMap &singleFrameProperties, PropertyMap &tiplProperties, PropertyMap &tmclProperties)

## Detailed Description

An ID3v2 custom text identification frame implementation.

This is a specialization of text identification frames that allows for user defined entries. Each entry has a description in addition to the normal list of fields that a text identification frame has.

This description identifies the frame and must be unique.

## Constructor & Destructor Documentation

## UserTextIdentificationFrame() [1/4]

TagLib::ID3v2::UserTextIdentificationFrame::UserTextIdentificationFrame | ( | String::Type | encoding = String::Latin1 | ) |

explicit

Constructs an empty user defined text identification frame. For this to be a useful frame both a description and text must be set.

References TagLib::String::Latin1.

Referenced by find(), operator=(), txxxToKey(), and UserTextIdentificationFrame().

## UserTextIdentificationFrame() [2/4]

TagLib::ID3v2::UserTextIdentificationFrame::UserTextIdentificationFrame | ( | const ByteVector & | data | ) |

explicit

Creates a frame based on data.

## UserTextIdentificationFrame() [3/4]

TagLib::ID3v2::UserTextIdentificationFrame::UserTextIdentificationFrame | ( | const String & | description,
|  | const StringList & | values,
|  | String::Type | encoding = String::UTF8 )

Creates a user defined text identification frame with the given description and values.

References description(), and TagLib::String::UTF8.

## ~UserTextIdentificationFrame()

TagLib::ID3v2::UserTextIdentificationFrame::~UserTextIdentificationFrame | ( |  | ) |

override

## UserTextIdentificationFrame() [4/4]

TagLib::ID3v2::UserTextIdentificationFrame::UserTextIdentificationFrame | ( | const UserTextIdentificationFrame & |  | ) |

delete

References UserTextIdentificationFrame().

## Member Function Documentation

## asProperties()

PropertyMap TagLib::ID3v2::UserTextIdentificationFrame::asProperties | ( |  | ) | const

override virtual

A UserTextIdentificationFrame is parsed into a PropertyMap as follows:

- the key is the frame's description, uppercased
- if the description contains '::', only the substring after that separator is considered as key (compatibility with exfalso)
- if the above rules don't yield a valid key (e.g. containing non-ASCII characters), the returned map will contain an entry "TXXX/<description>" in its unsupportedData() list.
- The values will be copies of the fieldList().
- If the description() appears as value in fieldList(), it will be omitted in the value list, in order to be compatible with TagLib which copies the description() into the fieldList().

Reimplemented from TagLib::ID3v2::TextIdentificationFrame.

## description()

String TagLib::ID3v2::UserTextIdentificationFrame::description | ( |  | ) | const

Returns the description for this frame.

Referenced by find(), and UserTextIdentificationFrame().

## find()

UserTextIdentificationFrame * TagLib::ID3v2::UserTextIdentificationFrame::find | ( | const Tag * | tag,
|  | const String & | description )

static

Searches for the user defined text frame with the description description in tag. This returns null if no matching frames were found.

References description(), and UserTextIdentificationFrame().

## keyToTXXX()

String TagLib::ID3v2::UserTextIdentificationFrame::keyToTXXX | ( | const String & |  | ) |

static

Returns an appropriate TXXX frame description for the given free-form tag key.

## operator=()

UserTextIdentificationFrame & TagLib::ID3v2::UserTextIdentificationFrame::operator= | ( | const UserTextIdentificationFrame & |  | ) |

delete

References UserTextIdentificationFrame().

## setDescription()

void TagLib::ID3v2::UserTextIdentificationFrame::setDescription | ( | const String & | s | ) |

Sets the description of the frame to s. s must be unique. You can check for the presence of another user defined text frame of the same type using find() and testing for null.

## setText() [1/2]

void TagLib::ID3v2::UserTextIdentificationFrame::setText | ( | const String & | text | ) |

override virtual

Set the text of frame in the sanest way possible. This should only be reimplemented in frames where there is some logical mapping to text.

Note
  If the frame type supports multiple text encodings, this will not change the text encoding of the frame; the string will be converted to that frame's encoding. Please use the specific APIs of the frame types to set the encoding if that is desired.

Reimplemented from TagLib::ID3v2::TextIdentificationFrame.

## setText() [2/2]

void TagLib::ID3v2::UserTextIdentificationFrame::setText | ( | const StringList & | fields | ) |

## toString()

String TagLib::ID3v2::UserTextIdentificationFrame::toString | ( |  | ) | const

override virtual

This returns the textual representation of the data in the frame. Subclasses must reimplement this method to provide a string representation of the frame's data.

Reimplemented from TagLib::ID3v2::TextIdentificationFrame.

## txxxToKey()

String TagLib::ID3v2::UserTextIdentificationFrame::txxxToKey | ( | const String & |  | ) |

static

Returns a free-form tag name for the given ID3 frame description.

References TAGLIB_MSVC_SUPPRESS_WARNING_NEEDS_TO_HAVE_DLL_INTERFACE, and UserTextIdentificationFrame().

## Friends And Related Symbol Documentation

## FrameFactory

friend class FrameFactory

friend

References FrameFactory.

Referenced by FrameFactory.

The documentation for this class was generated from the following file:

- textidentificationframe.h